(define a 0) 

(define (add-stroeme s t)
    (cond ((null? s) t)
          ((null? t) s)
          (else 
           (begin
             (set! a (+ a 1))
             (cons (+ (car s) (car t)) 
		   (delay (add-stroeme (force (cdr s)) (force (cdr t)))))))))
 
(define fibs (cons 0 (delay (cons 1 
			          (delay (add-stroeme (force (cdr fibs)) 
						      fibs))))))
 
(define (take n s)
  (if (= n 0)
      '()
      (cons (car s) (take (- n 1) (force (cdr s))))))
  
  
(define (add-stroeme_l s t)
    (cond ((null? s) t)
          ((null? t) s)
          (else 
           (begin
             (set! a (+ a 1))
             (cons (+ (car s) (car t)) 
		   (lambda() (add-stroeme_l (( cdr s)) ((cdr t)))))))))
 
(define fibs_l (cons 0 
		     (lambda() (cons 1 
				     (lambda() (add-stroeme_l ((cdr fibs_l)) 
							      fibs_l))))))

(define (take_l n s)
  (if (= n 0)
      '()
      (cons (car s) (take_l (- n 1) ((cdr s))))))