(define leerer-forderung-strom '())
(define (leerer-forderung-strom? forderung) 
           (eq? forderung leerer-forderung-strom))
(define (konstr-forderung-strom forderung rest)(cons forderung rest))

(define (konstr-abheben betrag)(cons 'abheben betrag))
(define (konstr-einzahlen betrag)(cons 'einzahlen betrag))
(define (abheben? forderung) (eq? 'abheben (caar forderung)))
(define (einzahlen? forderung) (eq? 'einzahlen (caar forderung)))
(define (betrag forderung)(cdar forderung))

(define (konstr-konto kontostand forderung-strom)
    (define (abheben betrag)
      (if (>= kontostand betrag)
	  (cons (cons (- kontostand betrag) 'Ok)
		      (konstr-konto (- kontostand betrag) 
				    (cdr forderung-strom)))
	  (cons (cons kontostand "Deckung nicht ausreichend!")
		      (konstr-konto kontostand 
				    (cdr forderung-strom)))))
    (define (einzahlen betrag)
      (cons (cons (+ kontostand betrag) 'Ok)
		  (konstr-konto (+ kontostand betrag) 
		                (cdr forderung-strom))))
    (cond ((leerer-forderung-strom? forderung-strom) '())
	  ((abheben? forderung-strom) (abheben (betrag forderung-strom)))
	  ((einzahlen? forderung-strom) (einzahlen 
					 betrag forderung-strom)))
	  (else (cons (cons kontostand "Unbekannte Forderung!!!")
			    (konstr-konto kontostand
		                          (cdr forderung-strom))))))
		    
